function [pol_ott, exitflag]=traj_gen(WP,T,N,vi,alfa,Wid)

% Passage through the WP, and constraints over the very first and last
% velocities and accelerations


[A_sol,B_sol]=der_wp(N,WP,T,vi,alfa);

% Constraints on derivatives in the intermediate points

if size(WP,1)>2
    [A_con,B_con]=connections(N,WP,T);
    Aeq=[A_sol;A_con];Beq=[B_sol;B_con];
else
    Aeq=A_sol;Beq=B_sol;
end

% Corridor constraints if given
if isempty(Wid)~=1
    [Adis,Bdis]=corridors(N,WP,Wid,T);
else
    [r,c]=size(WP);
    M=r-1;
    nc=floor(((N-1)*M-4)/M); % halfway points
    Bdis=zeros(nc*M*c*2,1);
    Adis=zeros(nc*M*c*2,M*c*(N+1));
    %Adis=[];Bdis=[];
end

Q=matrix_Q(N,T,WP);
[pol_ott, exitflag]=optimal_trajectory(Q,Adis,Bdis,Aeq,Beq,N,WP);
